#include<iostream>
#include<cstdio>

using namespace std;

int main(){
int n,k;
scanf("%d%d",&n,&k);
int a[n];
for(int i=0;i<n;i++){
    scanf("%d",&a[i]);
}
int i=0,j=n-1;
while(k!=1){
   if(a[i]>a[j]){
    a[i]-=a[j];
    j--;
   }
   else{
    a[j]-=a[i];
    i++;
   }
   k--;
}
int m=a[i];
for(int x=i;x<j;x++){

    if(m<a[x+1]){
        m=a[x+1];
    }
}
printf("%d",m);
return 0;
}